package ffmpeg

import (
	"errors"
	"fyne.io/fyne/v2/lang"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/utils"
	"os/exec"
	"strings"
)

type FFmpegContract interface {
	GetPath() string
}

type ffmpeg struct {
	path string
}

func newFFmpeg(path string) (FFmpegContract, error) {
	if path == "" {
		return nil, errors.New(lang.L("errorFFmpeg"))
	}

	isCheck, err := checkFFmpegPath(path)
	if err != nil {
		return nil, err
	}
	if isCheck == false {
		return nil, errors.New(lang.L("errorFFmpeg"))
	}

	return &ffmpeg{
		path: path,
	}, nil
}

func (f *ffmpeg) GetPath() string {
	return f.path
}

func checkFFmpegPath(path string) (bool, error) {
	cmd := exec.Command(path, "-version")
	utils.PrepareBackgroundCommand(cmd)
	out, err := cmd.CombinedOutput()
	if err != nil {
		return false, err
	}
	if strings.Contains(strings.TrimSpace(string(out)), "ffmpeg") == false {
		return false, nil
	}
	return true, nil
}
