package main

import (
	"fyne.io/fyne/v2"
	"fyne.io/fyne/v2/app"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/application"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/application/setting"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/controller"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/ffmpeg"
	"git.kor-elf.net/kor-elf/gui-for-ffmpeg/internal/resources"
)

func main() {
	appMetadata := fyne.AppMetadata{
		ID:      "net.kor-elf.projects.gui-for-ffmpeg",
		Name:    "GUI for FFmpeg",
		Version: "0.9.0",
		Icon:    resources.IconAppLogoResource(),
	}
	app.SetMetadata(appMetadata)
	fyneApp := app.New()
	progressBarService := application.NewProgressBar()
	appSetting := setting.NewSetting(fyneApp)
	ffmpegService := ffmpeg.NewUtilities(appSetting)
	myApp := application.NewApp(fyneApp, appSetting, progressBarService, ffmpegService)
	mainController := controller.NewController(myApp)
	mainController.Start()
	myApp.Run()
}
